/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvcomponenttree.h
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#include <qvdta/qvdta.h>

#define	 NULL_NODE	256*256*256

/// \cond Not documented By now
namespace qvdta
{
class QVComponentTreeNode
	{
	public:
		uInt seedX, seedY;
		uInt child, brother, numChilds;
		uChar firstThreshold, lastThreshold;
		uInt area[256];
		bool inited;
	};

class QVComponentTree
	{
	public:
		QVComponentTree(uInt cols, uInt rows, const QVImage<uChar,1> image);
		~QVComponentTree();

		void pruneLowRegions(QVImage<uChar> &image, uInt area);
		void pruneHighRegions(QVImage<uChar> &image, uInt area);

	public:
		uInt numNodes, freePoints, totalPoints, leafNodes, rootNode, maxNodes;
		QVComponentTreeNode *nodes;

		uInt *nodeID;
		bool *valid;

		void getComponentTree(const QVImage<uChar> &image);
		void pruneLowComponentTreeAux(QVImage<uChar> &image, uInt minArea, uInt node, uInt validThreshold);
		void pruneHighComponentTreeAux(QVImage<uChar> &image, uInt minArea, uInt node, uInt validThreshold);
	};

uInt debug_print_componentTree(QVComponentTree &componentTree);
}
/// \endcond Not documented By now
